/*
 * Dialogos.java
 *
 * Created on 3 de noviembre de 2006, 12:47 PM
 *
 */
package gui;

import javax.swing.*;
/**
 *
 * @author almunoz
 */
public class Dialogos {
    
    private String nombreApp;
    /**
     * Creates a new instance of Dialogos
     * @param nombre El nombre de la aplicacin, ser el titulo mostrado en los dialogos
     */
    public Dialogos(String nombre) {
        JDialog.setDefaultLookAndFeelDecorated(true);
        nombreApp = nombre;
    }
    
    public void acercaDe(JFrame frame, String version, String fecha){
        String message = this.nombreApp + " \n" +
                         "Versin " + version + " \n" +
                         fecha + " \n\n" +
                         "Diego Muoz Luna \n" +
                         "Alejandro Muoz Andrade \n" +
                         "Estudiantes Ingenieria de Sistemas \n" +
                         "Universidad del Cauca \n" +
                         "Copyright \u00A9 2006 \n\n";
        String title = this.nombreApp + " - Acerca de...";
        JOptionPane.showMessageDialog(frame , message, title, JOptionPane.INFORMATION_MESSAGE);
    }
    
    public void informacion(JFrame frame, String mensaje){
        String titulo = this.nombreApp + " - Mensaje de Informacin";
        JOptionPane.showMessageDialog(frame, mensaje, titulo, JOptionPane.INFORMATION_MESSAGE);
    }
    
    public void advertencia(JFrame frame, String mensaje){
        String titulo = this.nombreApp + " - Mensaje de Advertencia";
        JOptionPane.showMessageDialog(frame, mensaje, titulo, JOptionPane.WARNING_MESSAGE);
    }
    
    public void error(JFrame frame, String mensaje){
        String titulo = this.nombreApp + " - Mensaje de Error";
        JOptionPane.showMessageDialog(frame , mensaje, titulo, JOptionPane.ERROR_MESSAGE);
    }
    
    /**
     * Muestra un dialogo con la pregunta pasada como parametro
     *
     * @return OK_OPTION Si es elegido el boton Aceptar
     * @return CANCEL_OPTION Si es elegido boton Cancelar
     */
    public int pregunta(JFrame frame, String mensaje){
        String titulo = this.nombreApp + " - Mensaje de Confirmacin";
        int opcion = JOptionPane.showConfirmDialog(frame, mensaje, titulo,
                                    JOptionPane.OK_CANCEL_OPTION,
                                    JOptionPane.QUESTION_MESSAGE);
        return opcion;
    }
    
    /**
     * Muestra un dialogo con la pregunta "Confirma que Desea Salir?"
     *
     * @return OK_OPTION Si es elegido el boton Aceptar
     * @return CANCEL_OPTION Si es elegido boton Cancelar
     */
    public int salir(JFrame frame){
        String mensaje = "Confirma que Desea Salir?";
        String titulo = this.nombreApp;
        int opcion = JOptionPane.showConfirmDialog(frame, mensaje, titulo,
                                    JOptionPane.OK_CANCEL_OPTION,
                                    JOptionPane.QUESTION_MESSAGE);
        return opcion;
    }
    
}
