/*
 * TravexFichaGUI.java
 *
 * Created on 16 de noviembre de 2006, 01:55 PM
 *
 */

package gui;

import logica.TravexFicha;
import java.awt.*;
import java.util.ArrayList;
import javax.swing.*;
import javax.swing.border.EtchedBorder;

/**
 *
 * @author almunoz
 */
public class TravexFichaGUI extends JPanel {
    public TravexFicha ficha;
    public JLabel top;
    public JLabel bottom;
    public JLabel left;
    public JLabel right;
    public static ArrayList<Color> colores = new ArrayList<Color>();
    
    /** Creates a new instance of TravexFichaGUI */
    public TravexFichaGUI(TravexFicha TrFicha) {
        ficha = new TravexFicha();
        ficha = TrFicha;
        
        java.awt.GridBagConstraints gridBagConstraints;
        top = new javax.swing.JLabel();
        bottom = new javax.swing.JLabel();
        left = new javax.swing.JLabel();
        right = new javax.swing.JLabel();
        
        setLayout(new java.awt.GridBagLayout());
        setBorder(javax.swing.BorderFactory.createEtchedBorder());
                                        
        top.setText(Integer.toString(ficha.top));
        top.setBackground(colores.get(ficha.top));
        top.setPreferredSize(new Dimension(30, 20));
        top.setHorizontalAlignment(SwingConstants.CENTER);
        top.setOpaque(true);
        top.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.RAISED));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        this.add(top, gridBagConstraints);

        bottom.setText(Integer.toString(ficha.bottom));
        bottom.setBackground(colores.get(ficha.bottom));
        bottom.setPreferredSize(new Dimension(30, 20));
        bottom.setHorizontalAlignment(SwingConstants.CENTER);
        bottom.setOpaque(true);
        bottom.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.RAISED));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 2;
        this.add(bottom, gridBagConstraints);

        left.setText(Integer.toString(ficha.left));
        left.setBackground(colores.get(ficha.left));
        left.setPreferredSize(new Dimension(30, 20));
        left.setHorizontalAlignment(SwingConstants.CENTER);
        left.setOpaque(true);
        left.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.RAISED));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        this.add(left, gridBagConstraints);

        right.setText(Integer.toString(ficha.right));
        right.setBackground(colores.get(ficha.right));
        right.setPreferredSize(new Dimension(30, 20));
        right.setHorizontalAlignment(SwingConstants.CENTER);
        right.setOpaque(true);
        right.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.RAISED));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        this.add(right, gridBagConstraints);
    }
    
    public void habilitarGUI(boolean habilitado){
        // Se muestra o no la ficha
        /*Dimension dim = this.getSize();
        this.setPreferredSize(dim);
        top.setVisible(habilitado);
        bottom.setVisible(habilitado);
        left.setVisible(habilitado);
        right.setVisible(habilitado);*/
                 
        // Se muestra la ficha habilitada o desabilitada
        top.setEnabled(habilitado);
        top.setOpaque(habilitado);
        bottom.setEnabled(habilitado);
        bottom.setOpaque(habilitado);
        left.setEnabled(habilitado);
        left.setOpaque(habilitado);
        right.setEnabled(habilitado);
        right.setOpaque(habilitado);
        if(habilitado){
            top.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.RAISED));
            bottom.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.RAISED));
            left.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.RAISED));
            right.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.RAISED));
        }
        else{
            top.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.RAISED, Color.WHITE, Color.LIGHT_GRAY));
            bottom.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.RAISED, Color.WHITE, Color.LIGHT_GRAY));
            left.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.RAISED, Color.WHITE, Color.LIGHT_GRAY));
            right.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.RAISED, Color.WHITE, Color.LIGHT_GRAY));
        }
    }
            
    public static void crearColores(int maxColores){
        int r = 0;
        int g = 0;
        int b = 0;
        int num = 150; // numero de colores a generar 0-255
        int inicio = 255-num; // numero del color de inicio 0-255
        colores = new ArrayList<Color>();
        for(int index=0; index<=maxColores; index++){
            r = (int)(Math.random()*num)+inicio;
            g = (int)(Math.random()*num)+inicio;
            b = (int)(Math.random()*num)+inicio;
            colores.add(new Color(r, g, b));
        }
    }
    
}
