/*
 * TravexGUI.java
 *
 * Created on 16 de noviembre de 2006, 02:57 PM
 *
 */

package gui;

import logica.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Stack;
import javax.swing.*;

/**
 *
 * @author  almunoz
 */
public class TravexGUI extends javax.swing.JFrame {
    public int tamano;
    public Travex juego;
    public TravexTableroGUI tableroOrdenadoGUI;
    public TravexTableroGUI tableroDesordenadoGUI;
    public TravexTableroGUI tableroFinalGUI;
    public Dialogos dialogos; 
    /** Para la Animacion */
    private int tiempo;
    private boolean animated;
    private javax.swing.Timer timer;
                
    /** Creates new form TravexGUI */
    public TravexGUI() {
        initComponents();
        dialogos = new Dialogos(this.getTitle());
        tamano = 3;
        tiempo = 1000;
        nuevoAction();
    }
    
    /**
     * Este es el algoritmo para la ordenacin del juego
     * Ejecuta la animacion cada vez que se ejecuta el reloj del objeto timer
     * Este tiempo es el valor especificado en la variable TIEMPO, dada en milisegundos
     */
    class AnimationListener implements ActionListener {
        public TravexFicha ficha;
        public TravexFichaGUI fichaGUI;
        public int right;
        public int bottom;
        public int indexBusqueda;
        
        public AnimationListener(){
            ficha = new TravexFicha();
            fichaGUI = new TravexFichaGUI(ficha);
            right = -1;
            bottom = -1;
            indexBusqueda = 0;
        }
        
        public void actionPerformed(ActionEvent evt) {
            if(!juego.ordenado){
                right = juego.calcularRight();
                bottom = juego.calcularBottom();
                ficha = juego.buscarFicha(indexBusqueda, right, bottom);
                
                if(ficha==null){
                    ficha = juego.tableroFinal.popFicha();
                    juego.tableroDesordenado.marcarFicha(ficha.posicion, false);
                    indexBusqueda = juego.pivotes.pop().intValue()+1;
                    
                    tableroFinalGUI.quitarFichaGUI();
                    tableroDesordenadoGUI.habilitarFichaGUI(ficha.posicion, true);
                    tableroFinalPanel.removeAll();
                    tableroFinalPanel.add(tableroFinalGUI, BorderLayout.NORTH);
                    tableroFinalPanel.validate();
                    tableroFinalPanel.repaint();
                }
                else{
                    juego.tableroFinal.pushFicha(ficha);
                    juego.tableroDesordenado.marcarFicha(ficha.posicion, true);
                    juego.pivotes.push(Integer.valueOf(ficha.posicion));
                    indexBusqueda = 0;
                    
                    fichaGUI = new TravexFichaGUI(ficha);
                    tableroFinalGUI.agregarFichaGUI(fichaGUI);
                    tableroDesordenadoGUI.habilitarFichaGUI(ficha.posicion, false);
                    tableroFinalPanel.removeAll();
                    tableroFinalPanel.add(tableroFinalGUI, BorderLayout.NORTH);
                    tableroFinalPanel.validate();
                    tableroFinalPanel.repaint();
                }
            }
            if(juego.tableroFinal.getSize()==juego.longitud){
                juego.ordenado = true;
                timer.stop();
                setInfo("Animacin Terminada");
            }
        }
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        sizeButtonGroup = new javax.swing.ButtonGroup();
        tiempoButtonGroup = new javax.swing.ButtonGroup();
        controlesPanel = new javax.swing.JPanel();
        resetButton = new javax.swing.JButton();
        playButton = new javax.swing.JButton();
        pauseButton = new javax.swing.JButton();
        stopButton = new javax.swing.JButton();
        endButton = new javax.swing.JButton();
        tablerosPanel = new javax.swing.JPanel();
        tableroInicialPanel = new javax.swing.JPanel();
        tableroFinalPanel = new javax.swing.JPanel();
        infoToolBar = new javax.swing.JToolBar();
        infoLabel = new javax.swing.JLabel();
        jMenuBar1 = new javax.swing.JMenuBar();
        juegoMenu = new javax.swing.JMenu();
        nuevoMenuItem = new javax.swing.JMenuItem();
        desordenarMenuItem = new javax.swing.JMenuItem();
        jSeparator1 = new javax.swing.JSeparator();
        salirMenuItem = new javax.swing.JMenuItem();
        opcionesMenu = new javax.swing.JMenu();
        sizeMenu = new javax.swing.JMenu();
        dosRadioButtonMenuItem = new javax.swing.JRadioButtonMenuItem();
        tresRadioButtonMenuItem = new javax.swing.JRadioButtonMenuItem();
        cuatroRadioButtonMenuItem = new javax.swing.JRadioButtonMenuItem();
        cincoRadioButtonMenuItem = new javax.swing.JRadioButtonMenuItem();
        seisRadioButtonMenuItem = new javax.swing.JRadioButtonMenuItem();
        tiempoMenu = new javax.swing.JMenu();
        tiempo10RadioButtonMenuItem = new javax.swing.JRadioButtonMenuItem();
        tiempo100RadioButtonMenuItem = new javax.swing.JRadioButtonMenuItem();
        tiempo250RadioButtonMenuItem = new javax.swing.JRadioButtonMenuItem();
        tiempo500RadioButtonMenuItem = new javax.swing.JRadioButtonMenuItem();
        tiempo1000RadioButtonMenuItem = new javax.swing.JRadioButtonMenuItem();
        ayudaMenu = new javax.swing.JMenu();
        contenidoMenuItem = new javax.swing.JMenuItem();
        acercaDeMenuItem = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Travex Animado");
        setResizable(false);
        controlesPanel.setLayout(new java.awt.GridBagLayout());

        controlesPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        resetButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/gui/images/restart.png")));
        resetButton.setText("Reset");
        resetButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                resetActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 10, 10);
        controlesPanel.add(resetButton, gridBagConstraints);

        playButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/gui/images/play.png")));
        playButton.setText("Play");
        playButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                playActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 10, 10);
        controlesPanel.add(playButton, gridBagConstraints);

        pauseButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/gui/images/pause.png")));
        pauseButton.setText("Pause");
        pauseButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                pauseActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 10, 10);
        controlesPanel.add(pauseButton, gridBagConstraints);

        stopButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/gui/images/stop.png")));
        stopButton.setText("Stop");
        stopButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                stopActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 10, 10);
        controlesPanel.add(stopButton, gridBagConstraints);

        endButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/gui/images/end.png")));
        endButton.setText("End");
        endButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                endActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 10, 10);
        controlesPanel.add(endButton, gridBagConstraints);

        tablerosPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        tableroInicialPanel.setLayout(new java.awt.BorderLayout());

        tableroInicialPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Tablero Inicial"));
        tableroInicialPanel.setMinimumSize(new java.awt.Dimension(200, 200));

        tableroFinalPanel.setLayout(new java.awt.BorderLayout());

        tableroFinalPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Tablero Final"));
        tableroFinalPanel.setMinimumSize(new java.awt.Dimension(200, 200));
        tableroFinalPanel.setPreferredSize(new java.awt.Dimension(200, 200));

        org.jdesktop.layout.GroupLayout tablerosPanelLayout = new org.jdesktop.layout.GroupLayout(tablerosPanel);
        tablerosPanel.setLayout(tablerosPanelLayout);
        tablerosPanelLayout.setHorizontalGroup(
            tablerosPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(tablerosPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(tableroInicialPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 21, Short.MAX_VALUE)
                .add(tableroFinalPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        tablerosPanelLayout.linkSize(new java.awt.Component[] {tableroFinalPanel, tableroInicialPanel}, org.jdesktop.layout.GroupLayout.HORIZONTAL);

        tablerosPanelLayout.setVerticalGroup(
            tablerosPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, tablerosPanelLayout.createSequentialGroup()
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .add(tablerosPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(tableroFinalPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(tableroInicialPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        tablerosPanelLayout.linkSize(new java.awt.Component[] {tableroFinalPanel, tableroInicialPanel}, org.jdesktop.layout.GroupLayout.VERTICAL);

        infoToolBar.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        infoToolBar.setFloatable(false);
        infoLabel.setText("   Informaci\u00f3n");
        infoToolBar.add(infoLabel);

        juegoMenu.setText("Juego");
        nuevoMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_F2, 0));
        nuevoMenuItem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/gui/images/new.png")));
        nuevoMenuItem.setText("Nuevo");
        nuevoMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                nuevoActionPerformed(evt);
            }
        });

        juegoMenu.add(nuevoMenuItem);

        desordenarMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_F3, 0));
        desordenarMenuItem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/gui/images/reload.png")));
        desordenarMenuItem.setText("Desordenar");
        desordenarMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                desordenarActionPerformed(evt);
            }
        });

        juegoMenu.add(desordenarMenuItem);

        juegoMenu.add(jSeparator1);

        salirMenuItem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/gui/images/exit.png")));
        salirMenuItem.setText("Salir");
        salirMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                salirActionPerformed(evt);
            }
        });

        juegoMenu.add(salirMenuItem);

        jMenuBar1.add(juegoMenu);

        opcionesMenu.setText("Opciones");
        sizeMenu.setIcon(new javax.swing.ImageIcon(getClass().getResource("/gui/images/size.png")));
        sizeMenu.setText("Tama\u00f1o");
        dosRadioButtonMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_2, java.awt.event.InputEvent.CTRL_MASK));
        sizeButtonGroup.add(dosRadioButtonMenuItem);
        dosRadioButtonMenuItem.setText("2x2");
        dosRadioButtonMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sizeActionPerformed(evt);
            }
        });

        sizeMenu.add(dosRadioButtonMenuItem);

        tresRadioButtonMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_3, java.awt.event.InputEvent.CTRL_MASK));
        sizeButtonGroup.add(tresRadioButtonMenuItem);
        tresRadioButtonMenuItem.setSelected(true);
        tresRadioButtonMenuItem.setText("3x3");
        tresRadioButtonMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sizeActionPerformed(evt);
            }
        });

        sizeMenu.add(tresRadioButtonMenuItem);

        cuatroRadioButtonMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_4, java.awt.event.InputEvent.CTRL_MASK));
        sizeButtonGroup.add(cuatroRadioButtonMenuItem);
        cuatroRadioButtonMenuItem.setText("4x4");
        cuatroRadioButtonMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sizeActionPerformed(evt);
            }
        });

        sizeMenu.add(cuatroRadioButtonMenuItem);

        cincoRadioButtonMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_5, java.awt.event.InputEvent.CTRL_MASK));
        sizeButtonGroup.add(cincoRadioButtonMenuItem);
        cincoRadioButtonMenuItem.setText("5x5");
        cincoRadioButtonMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sizeActionPerformed(evt);
            }
        });

        sizeMenu.add(cincoRadioButtonMenuItem);

        seisRadioButtonMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_6, java.awt.event.InputEvent.CTRL_MASK));
        sizeButtonGroup.add(seisRadioButtonMenuItem);
        seisRadioButtonMenuItem.setText("6x6");
        seisRadioButtonMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sizeActionPerformed(evt);
            }
        });

        sizeMenu.add(seisRadioButtonMenuItem);

        opcionesMenu.add(sizeMenu);

        tiempoMenu.setIcon(new javax.swing.ImageIcon(getClass().getResource("/gui/images/time.png")));
        tiempoMenu.setText("Tiempo");
        tiempoButtonGroup.add(tiempo10RadioButtonMenuItem);
        tiempo10RadioButtonMenuItem.setText("10 ms");
        tiempo10RadioButtonMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                tiempoActionPerformed(evt);
            }
        });

        tiempoMenu.add(tiempo10RadioButtonMenuItem);

        tiempoButtonGroup.add(tiempo100RadioButtonMenuItem);
        tiempo100RadioButtonMenuItem.setText("100 ms");
        tiempo100RadioButtonMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                tiempoActionPerformed(evt);
            }
        });

        tiempoMenu.add(tiempo100RadioButtonMenuItem);

        tiempoButtonGroup.add(tiempo250RadioButtonMenuItem);
        tiempo250RadioButtonMenuItem.setText("250 ms");
        tiempo250RadioButtonMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                tiempoActionPerformed(evt);
            }
        });

        tiempoMenu.add(tiempo250RadioButtonMenuItem);

        tiempoButtonGroup.add(tiempo500RadioButtonMenuItem);
        tiempo500RadioButtonMenuItem.setText("500 ms");
        tiempo500RadioButtonMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                tiempoActionPerformed(evt);
            }
        });

        tiempoMenu.add(tiempo500RadioButtonMenuItem);

        tiempoButtonGroup.add(tiempo1000RadioButtonMenuItem);
        tiempo1000RadioButtonMenuItem.setSelected(true);
        tiempo1000RadioButtonMenuItem.setText("1000 ms");
        tiempo1000RadioButtonMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                tiempoActionPerformed(evt);
            }
        });

        tiempoMenu.add(tiempo1000RadioButtonMenuItem);

        opcionesMenu.add(tiempoMenu);

        jMenuBar1.add(opcionesMenu);

        ayudaMenu.setText("Ayuda");
        contenidoMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_F1, 0));
        contenidoMenuItem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/gui/images/help.png")));
        contenidoMenuItem.setText("Contenido");
        contenidoMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                contenidoMenuItemActionPerformed(evt);
            }
        });

        ayudaMenu.add(contenidoMenuItem);

        acercaDeMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_F5, 0));
        acercaDeMenuItem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/gui/images/about.png")));
        acercaDeMenuItem.setText("Acerca de...");
        acercaDeMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                acercaDeMenuItemActionPerformed(evt);
            }
        });

        ayudaMenu.add(acercaDeMenuItem);

        jMenuBar1.add(ayudaMenu);

        setJMenuBar(jMenuBar1);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(infoToolBar, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 465, Short.MAX_VALUE)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, controlesPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, tablerosPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .add(controlesPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(tablerosPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(infoToolBar, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 25, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void endActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_endActionPerformed
        endAction();
    }//GEN-LAST:event_endActionPerformed

    private void resetActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_resetActionPerformed
        resetAction();
    }//GEN-LAST:event_resetActionPerformed

    private void stopActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_stopActionPerformed
        stopAction();
    }//GEN-LAST:event_stopActionPerformed

    private void pauseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_pauseActionPerformed
        pauseAction();
    }//GEN-LAST:event_pauseActionPerformed

    private void sizeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sizeActionPerformed
        sizeAction();
    }//GEN-LAST:event_sizeActionPerformed

    private void tiempoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_tiempoActionPerformed
        tiempoAction();
    }//GEN-LAST:event_tiempoActionPerformed

    private void nuevoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_nuevoActionPerformed
        nuevoAction();
    }//GEN-LAST:event_nuevoActionPerformed

    private void playActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_playActionPerformed
        playAction();
    }//GEN-LAST:event_playActionPerformed

    private void desordenarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_desordenarActionPerformed
        desordenarAction();
    }//GEN-LAST:event_desordenarActionPerformed

    private void contenidoMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_contenidoMenuItemActionPerformed
        ayudaAction();
    }//GEN-LAST:event_contenidoMenuItemActionPerformed

    private void acercaDeMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_acercaDeMenuItemActionPerformed
        acercaDeAction();
    }//GEN-LAST:event_acercaDeMenuItemActionPerformed

    private void salirActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_salirActionPerformed
        salirAction();
    }//GEN-LAST:event_salirActionPerformed
    
    public void ayudaAction(){
        dialogos.informacion(this, "La Ayuda no se encuentra disponible \n" +
                                   "desde la aplicacin por el momento.");
    }
    
    public void acercaDeAction(){
        dialogos.acercaDe(this, "1.0", "26 de Noviembre de 2006");
    }
    
    public void salirAction(){
        int salir = dialogos.salir(this);
        if(salir == JOptionPane.OK_OPTION){
            System.exit(0);
        }
    }
    
    public void sizeAction(){
        if(dosRadioButtonMenuItem.isSelected()){
            tamano = 2;
        }
        else if(tresRadioButtonMenuItem.isSelected()){
            tamano = 3;
        }
        else if(cuatroRadioButtonMenuItem.isSelected()){
            tamano = 4;
        }
        else if(cincoRadioButtonMenuItem.isSelected()){
            tamano = 5;
        }
        else if(seisRadioButtonMenuItem.isSelected()){
            tamano = 6;
        }
        else{
            tamano = 3;
        }
        nuevoAction();
    }
    
    public void tiempoAction(){
        if(tiempo10RadioButtonMenuItem.isSelected()){
            tiempo = 10;
        }
        else if(tiempo100RadioButtonMenuItem.isSelected()){
            tiempo = 100;
        }
        else if(tiempo250RadioButtonMenuItem.isSelected()){
            tiempo = 250;
        }
        else if(tiempo500RadioButtonMenuItem.isSelected()){
            tiempo = 500;
        }
        else if(tiempo1000RadioButtonMenuItem.isSelected()){
            tiempo = 1000;
        }
        else{
            tiempo = 100;
        }
        /* Asigna el tiempo de espera del Timer */
        timer.setDelay(tiempo);
    }
        
    public void nuevoAction(){
        // Si hay un objeto Timer y esta en ejecucin, lo detiene
        if(timer!=null){
            if(timer.isRunning()){
                timer.stop();
            }
        }
        
        juego = new Travex(tamano);
        juego.nuevo();
        TravexFichaGUI.crearColores(juego.longitud);
        tableroOrdenadoGUI = new TravexTableroGUI(juego.tableroOrdenado);
        /** Para crear el timer de la animacion */
        animated = false;
        timer = new javax.swing.Timer(tiempo, new AnimationListener());
                       
        tableroInicialPanel.setBorder(BorderFactory.createTitledBorder("Tablero Inicial - Ordenado"));
        tableroInicialPanel.removeAll();
        tableroInicialPanel.add(tableroOrdenadoGUI, BorderLayout.NORTH);
        tableroFinalPanel.removeAll();
                
        tableroInicialPanel.validate();
        tableroInicialPanel.repaint();
        tableroFinalPanel.validate();
        tableroFinalPanel.repaint();
        pack();
        setInfo("Presione el botn Play para iniciar la animacin");
    }
    
    public void desordenarAction(){
        if(juego.ordenado){
            dialogos.informacion(this, "El juego ya se termino. \n" +
                                       "No puede desordenar el tablero ahora.");
        }
        else if(animated){
            dialogos.informacion(this, "La animacin ya comenzo. \n" +
                                       "No puede desordenar el tablero ahora.");
        }
        else if(!animated){
            juego.crearDesordenado();
            tableroDesordenadoGUI = new TravexTableroGUI(juego.tableroDesordenado);
            
            tableroInicialPanel.setBorder(BorderFactory.createTitledBorder("Tablero Inicial - Desordenado"));
            tableroInicialPanel.removeAll();
            tableroInicialPanel.add(tableroDesordenadoGUI, BorderLayout.NORTH);
            tableroInicialPanel.validate();
            tableroInicialPanel.repaint();
            setInfo("Presione el botn Play para iniciar la animacin");
        }
    }

    public void playAction(){
        if(juego.ordenado){
            dialogos.informacion(this, "El juego ya se termino. \n" +
                                       "Inicie un juego nuevo o presione el \n" +
                                       "botn Reset para reiniciar el juego.");
        }
        else{
            if(!juego.desordenado){
                desordenarAction();
            }
            if(timer.isRunning()){
                dialogos.informacion(this, "La animacin ya se inicio.");
            }
            else if(!timer.isRunning()){
                if(animated){
                    timer.start();
                    setInfo("Animacin Iniciada");
                }
                else{
                    tableroFinalGUI = new TravexTableroGUI(tamano);
                    animated = true;
                    timer.restart();
                    setInfo("Animacin Iniciada");
                }
            }
        }
    }
    
    public void pauseAction(){
        if(juego.ordenado){
            dialogos.informacion(this, "El juego ya se termino. \n" +
                                       "Inicie un juego nuevo o presione el \n" +
                                       "botn Reset para reiniciar el juego.");
        }
        else if(!animated){
            dialogos.informacion(this, "La animacin no se ha iniciado.");
        }
        else if(animated){
            if(timer.isRunning()){
                timer.stop();
                setInfo("Animacin Pausada");
            }
            else{
                timer.start();
                setInfo("Animacin Iniciada");
            }
        }
    }
    
    public void stopAction(){
        if(juego.ordenado){
            dialogos.informacion(this, "El juego ya se termino. \n" +
                                       "Inicie un juego nuevo o presione el \n" +
                                       "botn Reset para reiniciar el juego.");
        }
        else if(!animated){
            dialogos.informacion(this, "La animacin no se ha iniciado.");
        }
        else if(animated){
            if(timer.isRunning()){
                timer.stop();
                setInfo("Animacin Terminada");
                
                juego.jugar();
                tableroFinalGUI = new TravexTableroGUI(juego.tableroFinal);
            
                tableroDesordenadoGUI.habilitarFichas(false);
                tableroFinalPanel.removeAll();
                tableroFinalPanel.add(tableroFinalGUI, BorderLayout.NORTH);
                tableroFinalPanel.validate();
                tableroFinalPanel.repaint();
            }
        }
    }
    
    public void resetAction(){
        if(!animated && !juego.ordenado){
            dialogos.informacion(this, "La animacin no se ha iniciado.");
        }
        else{
            timer.stop();
            timer = new javax.swing.Timer(tiempo, new AnimationListener());
            juego.pivotes = new Stack<Integer>();
            juego.tableroFinal = new TravexTablero(tamano);
            tableroFinalGUI = new TravexTableroGUI(tamano);
            animated = false;
            juego.ordenado = false;
            juego.tableroDesordenado.marcarFichas(false);
            setInfo("Presione el botn Play para iniciar la animacin");
            
            tableroDesordenadoGUI.habilitarFichas(true);
            tableroFinalPanel.removeAll();
            tableroFinalPanel.add(tableroFinalGUI, BorderLayout.NORTH);
            tableroFinalPanel.validate();
            tableroFinalPanel.repaint();
        }
    }
    
    public void endAction(){
        if(juego.ordenado){
            dialogos.informacion(this, "El juego ya se termino. \n" +
                                       "Inicie un juego nuevo o presione el \n" +
                                       "botn Reset para reiniciar el juego.");
        }
        else{
            if(!juego.desordenado){
                desordenarAction();
            }
            timer.stop();
            setInfo("Animacin Terminada");
            
            juego.jugar();
            tableroFinalGUI = new TravexTableroGUI(juego.tableroFinal);
            
            tableroDesordenadoGUI.habilitarFichas(false);
            tableroFinalPanel.removeAll();
            tableroFinalPanel.add(tableroFinalGUI, BorderLayout.NORTH);
            tableroFinalPanel.validate();
            tableroFinalPanel.repaint();
        }
    }
    
    public void setInfo(String strInfo){
        StringBuffer info = new StringBuffer("   ");
        info.append(strInfo);
        infoLabel.setText(info.toString());
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        //setDefaultLookAndFeelDecorated(true);
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new TravexGUI().setVisible(true);
            }
        });
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenuItem acercaDeMenuItem;
    private javax.swing.JMenu ayudaMenu;
    private javax.swing.JRadioButtonMenuItem cincoRadioButtonMenuItem;
    private javax.swing.JMenuItem contenidoMenuItem;
    private javax.swing.JPanel controlesPanel;
    private javax.swing.JRadioButtonMenuItem cuatroRadioButtonMenuItem;
    private javax.swing.JMenuItem desordenarMenuItem;
    private javax.swing.JRadioButtonMenuItem dosRadioButtonMenuItem;
    private javax.swing.JButton endButton;
    private javax.swing.JLabel infoLabel;
    private javax.swing.JToolBar infoToolBar;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JMenu juegoMenu;
    private javax.swing.JMenuItem nuevoMenuItem;
    private javax.swing.JMenu opcionesMenu;
    private javax.swing.JButton pauseButton;
    private javax.swing.JButton playButton;
    private javax.swing.JButton resetButton;
    private javax.swing.JMenuItem salirMenuItem;
    private javax.swing.JRadioButtonMenuItem seisRadioButtonMenuItem;
    private javax.swing.ButtonGroup sizeButtonGroup;
    private javax.swing.JMenu sizeMenu;
    private javax.swing.JButton stopButton;
    private javax.swing.JPanel tableroFinalPanel;
    private javax.swing.JPanel tableroInicialPanel;
    private javax.swing.JPanel tablerosPanel;
    private javax.swing.JRadioButtonMenuItem tiempo1000RadioButtonMenuItem;
    private javax.swing.JRadioButtonMenuItem tiempo100RadioButtonMenuItem;
    private javax.swing.JRadioButtonMenuItem tiempo10RadioButtonMenuItem;
    private javax.swing.JRadioButtonMenuItem tiempo250RadioButtonMenuItem;
    private javax.swing.JRadioButtonMenuItem tiempo500RadioButtonMenuItem;
    private javax.swing.ButtonGroup tiempoButtonGroup;
    private javax.swing.JMenu tiempoMenu;
    private javax.swing.JRadioButtonMenuItem tresRadioButtonMenuItem;
    // End of variables declaration//GEN-END:variables
    
}
