/*
 * TravexTableroGUI.java
 *
 * Created on 16 de noviembre de 2006, 02:16 PM
 *
 */

package gui;

import logica.*;
import java.awt.*;
import java.util.Stack;
import javax.swing.*;

/**
 *
 * @author almunoz
 */
public class TravexTableroGUI extends JPanel {
    public TravexTablero tablero;
    public Stack<TravexFichaGUI> lstFichasGUI;
    
    /** Creates a new instance of TravexTableroGUI */
    public TravexTableroGUI(TravexTablero tab) {
        TravexFicha ficha = new TravexFicha();
        TravexFichaGUI fichaGUI;
        tablero = new TravexTablero(tab.getTamano());
        lstFichasGUI = new Stack<TravexFichaGUI>();
        
        tablero = tab;
        setLayout(new java.awt.GridLayout(0, tablero.getTamano()));
        for(int index=0; index<tablero.getSize(); index++){
            ficha = tablero.getFicha(index);
            fichaGUI = new TravexFichaGUI(ficha);
            agregarFichaGUI(fichaGUI);
        }
    }
    
    /** Creates a new instance of TravexTableroGUI */
    public TravexTableroGUI(int tam) {
        tablero = new TravexTablero(tam);
        lstFichasGUI = new Stack<TravexFichaGUI>();
        
        setLayout(new java.awt.GridLayout(0, tam));
    }
    
     public int getSizeGUI(){
        return lstFichasGUI.size();
    }
     
    public void agregarFichaGUI(TravexFichaGUI fichaGUI){
        lstFichasGUI.push(fichaGUI); // Agrega la ficha a la pila
        this.add(fichaGUI); // Agrega la ficha al panel visual
    }
    
    public void quitarFichaGUI(){
        TravexFichaGUI fichaGUI = new TravexFichaGUI(new TravexFicha());
        fichaGUI = lstFichasGUI.pop(); // Quita la ficha de la pila
        this.remove(fichaGUI); // Quita la ficha del panel visual
    }
    
    public void setFichaGUI(int index, TravexFichaGUI fichaGUI){
        lstFichasGUI.set(index, fichaGUI);
    }
    
    public TravexFichaGUI getFichaGUI(int index){
        return lstFichasGUI.get(index);
    }
    
    public void habilitarFichaGUI(int index, boolean habilitado){
        getFichaGUI(index).habilitarGUI(habilitado);
    }
    
    public void habilitarFichas(boolean habilitado){
        for(int index=0; index<getSizeGUI(); index++){
            getFichaGUI(index).habilitarGUI(habilitado);
        }
    }
    
}
