/*
 * Travex.java
 *
 * Created on 15 de noviembre de 2006, 06:18 PM
 *
 */

package logica;

import java.util.Stack;

/**
 *
 * @author almunoz
 */
public class Travex {
    public int tamano;
    public int longitud;
    public boolean ordenado;
    public boolean desordenado;
    public TravexTablero tableroOrdenado;
    public TravexTablero tableroDesordenado;
    public TravexTablero tableroFinal;
    public Stack<Integer> pivotes;
    
    /** Creates a new instance of Travex */
    public Travex(int tam) {
        tamano = tam;
        longitud = tamano*tamano;
        ordenado = false;
        desordenado = false;
        tableroOrdenado = new TravexTablero(tamano);
        tableroDesordenado = new TravexTablero(tamano);
        tableroFinal = new TravexTablero(tamano);
        pivotes = new Stack<Integer>();
    }
    
    public void nuevo(){
        crearOrdenado();
        pivotes = new Stack<Integer>();
    }
    
    public void crearOrdenado(){
        tableroOrdenado.crearOrdenado();
    }
    
    public void crearDesordenado(){
        desordenado = true;
        tableroDesordenado.crearDesordenado(tableroOrdenado);
    }
    
    public TravexFicha buscarFicha(int indexBusqueda, int rightValue, int bottomValue){
        return tableroDesordenado.buscarFicha(indexBusqueda, rightValue, bottomValue);
    }
    
    public int calcularRight(){
        int right = -1;
        int indexLeft = tableroFinal.getSize() - 1;
        
        if(indexLeft >= 0){
            right = tableroFinal.getFicha(indexLeft).right;
        }
        return right;
    }
    
    public int calcularBottom(){
        int bottom = -1;
        int indexTop = tableroFinal.getSize() - tamano;
        
        if(indexTop >= 0){
            bottom = tableroFinal.getFicha(indexTop).bottom;
        }
        return bottom;
    }
    
    public void jugar(){
        TravexFicha ficha = new TravexFicha();
        int right = -1;
        int bottom = -1;
        int indexBusqueda = 0;
                
        while(!ordenado){
            if(tableroFinal.getSize()==longitud){
                ordenado = true;
            }
            else{
                right = calcularRight();
                bottom = calcularBottom();
                ficha = buscarFicha(indexBusqueda, right, bottom);
                
                if(ficha==null){
                    ficha = tableroFinal.popFicha();
                    tableroDesordenado.marcarFicha(ficha.posicion, false);
                    indexBusqueda = pivotes.pop().intValue()+1;
                }
                else{
                    tableroFinal.pushFicha(ficha);
                    tableroDesordenado.marcarFicha(ficha.posicion, true);
                    pivotes.push(Integer.valueOf(ficha.posicion));
                    indexBusqueda = 0;
                }
            }
        }
    }
    
}
