/*
 * TravexTablero.java
 *
 * Created on 15 de noviembre de 2006, 06:19 PM
 *
 */

package logica;

import java.util.Stack;

/**
 *
 * @author almunoz
 */
public class TravexTablero {
    private int tamano;
    private int longitud; 
    public Stack<TravexFicha> lstFichas;
    
    /** Creates a new instance of TravexTablero */
    public TravexTablero(int tam) {
        tamano = tam;
        longitud = tamano*tamano;
        lstFichas = new Stack<TravexFicha>();
    }
    
    public int getTamano(){
        return tamano;
    }
    
    public int getSize(){
        return lstFichas.size();
    }
    
    public void pushFicha(TravexFicha ficha){
        lstFichas.push(ficha);
    }
    
    public TravexFicha popFicha(){
        return lstFichas.pop();
    }
    
    public void setFicha(int index, TravexFicha ficha){
        lstFichas.set(index, ficha);
    }
    
    public TravexFicha getFicha(int index){
        return lstFichas.get(index);
    }
    
    public void iniciar(){
        lstFichas = new Stack<TravexFicha>();
        for(int index=0; index<longitud; index++){
            pushFicha(new TravexFicha(index));
        }
    }
    
    public void crearOrdenado(){
        TravexFicha ficha;
        int indexLeft;
        int indexTop;
        
        lstFichas = new Stack<TravexFicha>();
        for(int index=0; index<longitud; index++){
            ficha = new TravexFicha(index);
            indexLeft = index - 1;
            indexTop = index - tamano;
            if(indexLeft < 0){
                ficha.left = (int)(Math.random()*(longitud+1));
            }
            else{
                ficha.left = getFicha(indexLeft).right;
            }
            if(indexTop < 0){
                ficha.top = (int)(Math.random()*(longitud+1));
            }
            else{
                ficha.top = getFicha(indexTop).bottom;
            }
            ficha.right = (int)(Math.random()*(longitud+1));
            ficha.bottom = (int)(Math.random()*(longitud+1));
            
            pushFicha(ficha);
        }
    }
    
    public void crearDesordenado(TravexTablero ordenado){
        TravexFicha ficha = new TravexFicha();
        boolean libre[] = new boolean[longitud];
        int indexLibre = 0;
        
        for(indexLibre=0; indexLibre<longitud; indexLibre++){
            libre[indexLibre] = true;
        }
        
        iniciar();
        for(int index=0; index<ordenado.getSize(); index++){
            ficha = ordenado.getFicha(index);
            indexLibre = (int)(Math.random()*longitud);
            while(!libre[indexLibre]){
                indexLibre = (int)(Math.random()*longitud);
            }
            libre[indexLibre] = false;
            ficha.posicion = indexLibre;
            setFicha(indexLibre, ficha);
        }
    }
    
    public TravexFicha buscarFicha(int indexBusqueda, int rightValue, int bottomValue){
        TravexFicha ficha = new TravexFicha();
        
        for(int index=indexBusqueda; index<getSize(); index++){
            ficha = getFicha(index);
            if(!ficha.marcada && ficha.comparar(rightValue, bottomValue)){
                return ficha;
            }
        }
        return null;
    }
    
    public void marcarFicha(int index, boolean marca){
        getFicha(index).marcada = marca;
    }
    
    public void marcarFichas(boolean marca){
        for(int index=0; index<getSize(); index++){
            getFicha(index).marcada = marca;
        }
    }
    
}
